REM Traffic Capacity Planner Program
REM $DYNAMIC
DIM FACTORIAL#(60)
DIM E#(4, 40)
DIM GOS(10)
REM E is the offered load in Erlangs
REM E#(I,S) contains resulting traffic for GOS of I when S ports used
REM PORT is the number of ports, dial in lines or trunks
REM GOS is the grade of service for port or channel PORT with traffic E
MAXPORT = 40
CLS
FOR I = 1 TO 4
READ GOS(I)
NEXT I
DATA .01,.02,.04,.08
LPRINT TAB(25); "Capacity Planner"
LPRINT
LPRINT "This program computes and displays a table containing the traffic"
LPRINT "carrying capacity for a group of ports that will result in"
LPRINT "               a predefined grade of service"
LPRINT
        LPRINT
        LPRINT " NUMBER OF PORTS         TRAFFIC SUPPORTED IN ERLANGS PER PORT"
        LPRINT "                             FOR INDICATED GRADE OF SERVICE"
        LPRINT TAB(30);
        LPRINT USING "#.###   #.###   "; GOS(1); GOS(2);
        LPRINT USING "#.###   #.### "; GOS(3); GOS(4)
        LPRINT
GOSUB 100  'compute factorial 1 TO factorial MAXPORT
REM vary grade of service from .01 to .08 or 1 in 100 to 1 in 12.5 calls busy
        FOR I = 1 TO 4
      
        GOS# = GOS(I)
        REM Vary ports from 1 to MAXPORT
            FOR PORT = 1 TO MAXPORT
                        REM Find traffic in Erlangs that provides GOS
                        LOW# = 1
                        HIGH# = 100000
                          TRY# = (LOW# + HIGH#) / 2
1  E# = TRY# / 1000
PORT# = PORT
                        N# = (E# ^ PORT#) / FACTORIAL#(PORT)
                        D# = 0
                        FOR S = 0 TO PORT
                        S# = S
                        D# = D# + (E# ^ S#) / FACTORIAL#(S)
                        NEXT S
                        IF ABS(GOS# - N# / D#) < .0005 THEN GOTO 5
                        IF GOS# - N# / D# < 0 THEN
                                    OLD# = TRY#
                                    TRY# = TRY# - ((TRY# - LOW#) / 2)
                                    GOTO 1
                         ELSEIF GOS# - N# / D# > 0 THEN
                                TRY# = (TRY# + OLD#) / 2
                                GOTO 1
                         END IF
5 E#(I, PORT) = TRY# / 1000
NEXT PORT
                       NEXT I
REM output results   
        FOR S = 1 TO MAXPORT
                LPRINT TAB(4); S;
                 LPRINT TAB(29);
                LPRINT USING "##.###  ##.###  "; E#(1, S); E#(2, S);
                LPRINT USING "##.###  ##.###"; E#(3, S); E#(4, S)
                NEXT S
        END
REM subroutine to compute factorials
100 FOR I = 1 TO MAXPORT
        p# = 1
                FOR J = I TO 1 STEP -1
                p# = p# * J
                NEXT J
        FACTORIAL#(I) = p#
        NEXT I
        FACTORIAL#(0) = 1
        RETURN



